#import <appkit/appkit.h>

/*
DrawCell:
	Subclasses from Object
	August 5, 1993
	Sean Luke
	
Subclasses of DrawCell can draw themselves as individual drawing items in 
a DrawView.
*/


@interface DrawCell:Object	
	{
	NXPoint		coord;								// origin coordinate
	BOOL		selected;
	id			view;
	}

- init;
- setView:the_view;
- setPoint:(NXPoint*) the_point;					// sets NXPoint
- drawSelf:(const NXRect*) rects:(int) rectCount;	// draws the cell
- (BOOL) hit:(NXEvent*) theEvent;					// tests if hit at a point
- mouseDown:(NXEvent*) theEvent;					// handles mouseDown events
- mouseDragged:(NXEvent*) theEvent;				// ... etc.
- mouseUp:(NXEvent*) theEvent;						// ... etc.
- select;											// sets selected to YES
- deselect;											// ...to NO
- (BOOL) isSelected;								// returns selected

@end